!**********************************************************************
!   pi.f - compute pi by integrating f(x) = 4/(1 + x**2)     
!****************************************************************************
! This tests nothing in particluar but is a very simple program. If this doesn't
! work you've really got problems
program main
  use mpi
  implicit none
  integer, parameter :: rd_kind = kind(0.d0)
  real(rd_kind), parameter :: pic = 3.141592653589793238462643
  real(rd_kind) :: mypi, pi, h, sum, x
  character(len=FMPI_MAX_PROCESSOR_NAME) :: p_name
  integer n, rank, numprocs, i
  
  call fmpi_init
  call fmpi_comm_rank(rank)
  call fmpi_comm_size(numprocs) 
  call fmpi_get_processor_name(p_name,n)
  print *, "Process", rank, "called ", p_name(1:n)," of", numprocs, "is alive"
  if (fmpi_is_root(rank)) n = 1000
  call fmpi_bcast(n)  
  h = 1d0/n    !calculate the interval size
  sum  = 0d0
  do i = rank+1, n, numprocs
     x = h * (real(i,rd_kind) - 0.5d0)
     sum = sum + 4d0 / (1d0 + x*x)
  end do
  mypi = h * sum
  !                                 collect all the partial sums
  call fmpi_reduce(mypi,pi,FMPI_SUM)
  if (fmpi_is_root(rank)) then 
     write(*,&
          ("('  pi is approximately: ',F18.16,'  Error is: ', F18.16)"))&
          pi, abs(pi - pic)
  endif
  call fmpi_finalize
end program main




