! jim@orange.lowtem.hokudai.ac.jp
program test_derived
  use mpi
  use test_f90_def

  implicit none

  type(test_t) :: msg,msga(3),msgb(3),bmsg,rmsg

  integer :: rank, num
  integer :: src = 0
  integer :: dest = 1

  call fmpi_init
  call fmpi_comm_rank(rank)
  call fmpi_comm_size(num)


  ! Blank message
  bmsg%name="blank"
  bmsg%x=(/-1, -1, -1/)
  bmsg%a=(/-1, -1/)


  msgb = (/bmsg, bmsg, bmsg/)
  rmsg = bmsg

  msg%name="Nadar"
  msg%x=(/0.1,0.2,0.3/)
  msg%a=(/1,2/)

  msga(1)%name="Hello"
  msga(1)%x=(/1.1,1.2,1.3/)
  msga(1)%a=(/11,12/)
  msga(2)%name="Ciao "
  msga(2)%x=(/2.1,2.2,2.3/)
  msga(2)%a=(/21,22/)
  msga(3)%name="Damm "
  msga(3)%x=(/3.1,3.2,3.3/)
  msga(3)%a=(/31,32/)

  if (num < 2) then
     print *,' This test needs at least two processors. Aborting...'
     call fmpi_abort(601)
  end if

  if(rank==src) then
     call fmpi_send(msg, dest, mpi_tag_t(1))   ! scalar send
     call fmpi_send(msga, dest, mpi_tag_t(2))  ! vector send
  else if (rank==dest) then
     call fmpi_recv(rmsg, src, mpi_tag_t(1))
     if (.not.(rmsg == msg)) then
        print *, 'Scalar recieve failed. Aborting...'
        print *, 'Received ', rmsg
        print *, 'Sent ', msg
        print *,'Scalar  structure test failed.'
        call fmpi_abort(602)
     end if
     call fmpi_recv(msgb, src, mpi_tag_t(2))
     if (.not.all(msgb == msga)) then
        print *, 'Array recieve failed. Aborting...'
        print *, 'Received ', msgb
        print *, 'Sent ', msga
        print *,'array  structure test failed.'
        call fmpi_abort(603)
     end if
     print *,'Scalar and array structure successfuly test completed.'
  end if
  call fmpi_finalize
end program test_derived
   
