! fortran program to test the basic fortran types
program typebasef
  use mpi
  implicit none
  type(mpi_datatype_t) :: basictypes(8)
  character(len=*), parameter :: basicnames(8) = (/&
       'INTEGER         ', &
       'REAL            ', &
       'DOUBLE PRECISION', &
       'COMPLEX         ', &
       'LOGICAL         ', &
       'CHARACTER       ', &
       'BYTE            ', &
       'PACKED          '/)

  integer :: i, errcnt=0
  integer sz, extent, ub, lb

  call fmpi_init
  basictypes =  (/FMPI_INTEGER, FMPI_REAL, FMPI_DOUBLE_PRECISION, &
       FMPI_COMPLEX, FMPI_LOGICAL, FMPI_CHARACTER, FMPI_BYTE, FMPI_PACKED/)  
  do  i=1,size(basictypes) 
     call fmpi_type_size( basictypes(i), sz)
     call fmpi_type_extent( basictypes(i), extent)
     call fmpi_type_lb( basictypes(i), lb)
     call fmpi_type_ub( basictypes(i), ub)
     if (sz /= extent) then
        errcnt = errcnt + 1
        print *, "size (", sz, ") != extent (", extent, &
             ") for basic type ", basicnames(i)
     endif
     if (lb /= 0) then
        errcnt = errcnt + 1
        print *, "lowerbound of ", basicnames(i), " was ", lb, " instead of 0" 
     endif
     if (ub /= extent) then
        errcnt = errcnt + 1
        print *, "upperbound of ", basicnames(i), " was ", ub, " instead of ", &
             extent
     endif
  end do

  if (errcnt > 0) then
     print *, "found ", errcnt, " errors in testing fortran types"
     call fmpi_abort(412)
  else
     if (fmpi_root) print *, " typebasef test successful"
  endif
  call fmpi_finalize
end program typebasef
